package com.maroontress.coverture.gcno;

import java.io.IOException;
import java.nio.ByteBuffer;

/**
   ARCS쥳ɤǤ

   arcs: header int32:block_no arc*
*/
public final class ArcsRecord {

    /** ȯȤʤ֥åμ̻ҤǤ */
    private int startIndex;

    /** ARC쥳ɤΥꥹȤǤ */
    private ArcRecord[] list;

    /**
       ХȥХåեARCS쥳ɤλĤϤARCS쥳ɤ
       ޤХȥХåեΰ֤ARCS쥳ɤΥϤľ
       ΰ֤ǤʤФʤޤϡХȥХåե
       ֤ARCS쥳ɤμΰ֤˰ưޤ

       @param bb ХȥХåե
       @throws IOException
    */
    public ArcsRecord(final ByteBuffer bb) throws IOException {
	int length = bb.getInt();
	int next = bb.position() + 4 * length;
	startIndex = bb.getInt();
	int num = (length - 1) / 2;
	list = new ArcRecord[num];
	for (int k = 0; k < num; ++k) {
	    list[k] = new ArcRecord(bb);
	}
	bb.position(next);
    }

    /**
       ȯȤʤ֥åμ̻Ҥޤ

       @return ȯȤʤ֥åμ̻
    */
    public int getStartIndex() {
	return startIndex;
    }

    /**
       ARC쥳ɤ֤ޤ

       @return ARC쥳ɤ
    */
    public ArcRecord[] getList() {
	return list;
    }
}
