package com.maroontress.coverture;

import java.io.PrintWriter;
import java.util.ArrayList;

/**
   ؿդΥΡɤȤʤܥ֥åǤ
*/
public final class Block {

    /** ֥åμ̻ҤǤ */
    private int id;

    /** ֥åΥե饰Ǥ */
    private int flags;

    /** 륨åפΥꥹȤǤ */
    private ArrayList<Arc> inArcs;

    /** ֽФ륨åפΥꥹȤǤ */
    private ArrayList<Arc> outArcs;

    /**
       Block is a call instrumenting site; does the call: ؿƤӽ
       ֥åǤ뤳Ȥ򼨤ޤ
    */
    private boolean callSite;

    /**
       Block is a landing pad for longjmp or throw: åν
       catchޤsetjmp()Ǥ뤳Ȥ򼨤ޤ
    */
    private boolean nonLocalReturn;

    /** ֥åб륽ɤιԥȥǤ */
    private LineEntry[] lines;

    /**
       XMLǥ֥åϤޤ

       @param out 
    */
    public void printXML(final PrintWriter out) {
	out.printf("<block id='%d' flags='0x%x' callSite='%b' "
		   + "nonLocalReturn='%b'>\n",
		   id, flags, callSite, nonLocalReturn);
	for (Arc arc : outArcs) {
	    out.printf("<arc destination='%d' fake='%b' onTree='%b' "
		       + "fallThrough='%b' callNonReturn='%b' "
		       + "nonLocalReturn='%b' />\n",
		       arc.getEnd().getId(), arc.isFake(), arc.isOnTree(),
		       arc.isFallThrough(), arc.isCallNonReturn(),
		       arc.isNonLocalReturn());
	}
	if (lines != null) {
	    for (LineEntry e : lines) {
		String fileName = e.getFileName();
		int[] nums = e.getLines();
		if (nums.length == 0) {
		    continue;
		}
		out.printf("<lines fileName='%s'>\n", XML.escape(fileName));
		for (int k = 0; k < nums.length; ++k) {
		    out.printf("<line number='%d' />\n", nums[k]);
		}
		out.printf("</lines>\n");
	    }
	}
	out.printf("</block>\n");
    }

    /**
       ֥åޤ

       @param id ֥åμ̻
       @param flags ֥åΥե饰
    */
    public Block(final int id, final int flags) {
	this.id = id;
	this.flags = flags;
	inArcs = new ArrayList<Arc>();
	outArcs = new ArrayList<Arc>();
    }

    /**
       ؿƤӽФ֥åɤꤷޤ

       @param b ؿƤӽФ֥åξtrueǤʤ
       false
    */
    public void setCallSite(final boolean b) {
	callSite = b;
    }

    /**
       catchޤsetjmp()ޤ֥åɤꤷޤ

       @param b catchޤsetjmp()ޤ֥åξtrue
       ʤfalse
    */
    public void setNonLocalReturn(final boolean b) {
	nonLocalReturn = b;
    }

    /**
       Υ֥å륨åɲäޤ

       @param arc å
    */
    public void addInArc(final Arc arc) {
	inArcs.add(arc);
    }

    /**
       Υ֥åФ륨åɲäޤ

       @param arc å
    */
    public void addOutArc(final Arc arc) {
	outArcs.add(arc);
    }

    /**
       Υ֥åιԥȥꤷޤ

       @param lines ԥȥ
    */
    public void setLines(final LineEntry[] lines) {
	this.lines = lines;
    }

    /**
       ̻Ҥޤ

       @return ̻
    */
    public int getId() {
	return id;
    }
}
